@use "sass:math";

/*Align element vertically and horizontally using absolute positioning*/
@mixin vertical_align($left, $right) {
  position: absolute;
  top: 50%;
  transform: translateY(-50%);
  left: $left;
  right: $right;
  z-index: 2;
}

/*Mixin for getting elements in a row, specifying the number of columns each element is needed to be given (news style)*/
@mixin inline_cards($span, $nth, $columns, $bottom, $prevn) {
  .view-content {
    display: flex;
    display: -ms-flexbox;
    flex-wrap: wrap;
  }

  .views-row,
  > .field__item {
    width: span($span of $columns);
    margin-right: gutter(of $columns);
    margin-bottom: $bottom + px;

    //used for responsive, if you don't want need it write 0
    &:nth-child(#{$prevn}n) {
      margin-right: gutter(of $columns);
    }
    
    &:nth-child(#{$nth}n) {
      margin-right: 0;
    }
  }
}

@mixin svgs($width,$height,$svg){
    width: width;
    height: height;
    background-image: url('../images/sprites/svg/' + $svg);
    background-size: contain;
    background-repeat: no-repeat;
}

@mixin svgsprite($icon, $type: all) {
	@if $type == all {
		// Shares the backgrounds
		@extend %sprite;
	}

	$iconMap: icon-attr($icon);

	// Outputs dimensions in em
	@if $type == all or $type == size {
		width: mq-px2em(map-get($iconMap, width) + 1);
		height: mq-px2em(map-get($iconMap, height) + 1);
	}

	// Outputs background position in em
	@if $type == all or $type == bg {
		background-position: mq-px2em(map-get($iconMap, x) - 5) mq-px2em(map-get($iconMap, y) - 5);
	}
}

/*Display elements on the same row using flex*/
@mixin same_row($alignh, $alignv) {
  display: flex;
  display: -ms-flexbox;
  align-items: $alignh;
  -ms-flex-align: $alignh;
  justify-content: $alignv;
  -ms-justify-content: $alignv;
}

/*Turn px into rem*/
@function strip_unit($number) {
  @if type-of($number) == 'number' and not unitless($number) {
    @return math.div($number, ($number * 0 + 1)); 
  }

  @return $number;
}

@function calculate_rem($size) {
  $remSize: calc($size / strip_unit($base-font));
  @return $remSize + rem;
}

@mixin font_size($size) {
  font-size: calculate_rem($size);
}

/*Mixin for overlays*/
@mixin overlay($color, $opacity) {
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background: rgba($color, $opacity);
  display: flex;
  align-items: center;
  justify-content: center;
}

/*Style your button*/
@mixin button($background, $color, $back_hover, $color_hover,$back_pressed, $color_pressed) {
  display: inline-block;
//   width: 240px;
  text-align: center;
  background-color: $background;
  color: $color;
  border: none;
  border-radius: 4px;
  text-decoration: none;
  padding: 10px 14px;
  transition: background-color 0.2s;

  &:hover {
    background: $back_hover;
    color: $color_hover;
  }
  &:active {
    background: $back_pressed;
    color: $color_pressed;
  }
}

@mixin flex-center {
    display: flex;
    justify-content: center;
    align-items: center;
}

@mixin card-shadow {
    box-shadow: 0 0.25rem 0.5rem rgba(0, 0, 0, 0.1);
}
